<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
<meta http-equiv="X-UA-Compatible" content="IE=9"/>
<meta name="generator" content="Doxygen 1.8.15"/>
<meta name="viewport" content="width=device-width, initial-scale=1"/>
<title>AlexaClientSDK: alexaClientSDK::avsCommon::sdkInterfaces::StateProviderInterface Class Reference</title>
<link href="tabs.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="jquery.js"></script>
<script type="text/javascript" src="dynsections.js"></script>
<link href="search/search.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="search/searchdata.js"></script>
<script type="text/javascript" src="search/search.js"></script>
<link href="doxygen.css" rel="stylesheet" type="text/css" />
</head>
<body>
<div id="top"><!-- do not remove this div, it is closed by doxygen! -->
<div id="titlearea">
<table cellspacing="0" cellpadding="0">
 <tbody>
 <tr style="height: 56px;">
  <td id="projectlogo"><img alt="Logo" src="avs-logo.png"/></td>
  <td id="projectalign" style="padding-left: 0.5em;">
   <div id="projectname">AlexaClientSDK
   &#160;<span id="projectnumber">1.13.0</span>
   </div>
   <div id="projectbrief">A cross-platform, modular SDK for interacting with the Alexa Voice Service</div>
  </td>
 </tr>
 </tbody>
</table>
</div>
<!-- end header part -->
<!-- Generated by Doxygen 1.8.15 -->
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:cf05388f2679ee054f2beb29a391d25f4e673ac3&amp;dn=gpl-2.0.txt GPL-v2 */
var searchBox = new SearchBox("searchBox", "search",false,'Search');
/* @license-end */
</script>
<script type="text/javascript" src="menudata.js"></script>
<script type="text/javascript" src="menu.js"></script>
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:cf05388f2679ee054f2beb29a391d25f4e673ac3&amp;dn=gpl-2.0.txt GPL-v2 */
$(function() {
  initMenu('',true,false,'search.php','Search');
  $(document).ready(function() { init_search(); });
});
/* @license-end */</script>
<div id="main-nav"></div>
<!-- window showing the filter options -->
<div id="MSearchSelectWindow"
     onmouseover="return searchBox.OnSearchSelectShow()"
     onmouseout="return searchBox.OnSearchSelectHide()"
     onkeydown="return searchBox.OnSearchSelectKey(event)">
</div>

<!-- iframe showing the search results (closed by default) -->
<div id="MSearchResultsWindow">
<iframe src="javascript:void(0)" frameborder="0" 
        name="MSearchResults" id="MSearchResults">
</iframe>
</div>

<div id="nav-path" class="navpath">
  <ul>
<li class="navelem"><a class="el" href="namespacealexa_client_s_d_k.html">alexaClientSDK</a></li><li class="navelem"><a class="el" href="namespacealexa_client_s_d_k_1_1avs_common.html">avsCommon</a></li><li class="navelem"><a class="el" href="namespacealexa_client_s_d_k_1_1avs_common_1_1sdk_interfaces.html">sdkInterfaces</a></li><li class="navelem"><a class="el" href="classalexa_client_s_d_k_1_1avs_common_1_1sdk_interfaces_1_1_state_provider_interface.html">StateProviderInterface</a></li>  </ul>
</div>
</div><!-- top -->
<div class="header">
  <div class="summary">
<a href="#pub-methods">Public Member Functions</a> &#124;
<a href="classalexa_client_s_d_k_1_1avs_common_1_1sdk_interfaces_1_1_state_provider_interface-members.html">List of all members</a>  </div>
  <div class="headertitle">
<div class="title">alexaClientSDK::avsCommon::sdkInterfaces::StateProviderInterface Class Reference<span class="mlabels"><span class="mlabel">abstract</span></span></div>  </div>
</div><!--header-->
<div class="contents">

<p><code>#include &lt;<a class="el" href="_state_provider_interface_8h_source.html">StateProviderInterface.h</a>&gt;</code></p>
<div class="dynheader">
Inheritance diagram for alexaClientSDK::avsCommon::sdkInterfaces::StateProviderInterface:</div>
<div class="dyncontent">
<div class="center"><img src="classalexa_client_s_d_k_1_1avs_common_1_1sdk_interfaces_1_1_state_provider_interface__inherit__graph.png" border="0" usemap="#alexa_client_s_d_k_1_1avs_common_1_1sdk_interfaces_1_1_state_provider_interface_inherit__map" alt="Inheritance graph"/></div>
<map name="alexa_client_s_d_k_1_1avs_common_1_1sdk_interfaces_1_1_state_provider_interface_inherit__map" id="alexa_client_s_d_k_1_1avs_common_1_1sdk_interfaces_1_1_state_provider_interface_inherit__map">
<area shape="rect" id="node2" href="classalexa_client_s_d_k_1_1afml_1_1_audio_activity_tracker.html" title="alexaClientSDK::afml\l::AudioActivityTracker" alt="" coords="284,477,434,516"/>
<area shape="rect" id="node3" href="classalexa_client_s_d_k_1_1afml_1_1_visual_activity_tracker.html" title="alexaClientSDK::afml\l::VisualActivityTracker" alt="" coords="283,540,435,579"/>
<area shape="rect" id="node4" href="classalexa_client_s_d_k_1_1avs_common_1_1avs_1_1_capability_agent.html" title="alexaClientSDK::avsCommon\l::avs::CapabilityAgent" alt="" coords="261,603,458,641"/>
<area shape="rect" id="node24" href="classalexa_client_s_d_k_1_1context_manager_1_1test_1_1_mock_state_provider.html" title="alexaClientSDK::contextManager\l::test::MockStateProvider" alt="" coords="250,665,468,704"/>
<area shape="rect" id="node25" href="classalexa_client_s_d_k_1_1integration_1_1test_1_1test_state_provider.html" title="alexaClientSDK::integration\l::test::testStateProvider" alt="" coords="267,728,451,767"/>
<area shape="rect" id="node5" href="classalexa_client_s_d_k_1_1avs_common_1_1sdk_interfaces_1_1_call_manager_interface.html" title="alexaClientSDK::avsCommon\l::sdkInterfaces::CallManagerInterface" alt="" coords="535,5,778,44"/>
<area shape="rect" id="node6" href="classalexa_client_s_d_k_1_1avs_common_1_1test_1_1_mock_capability_agent.html" title="alexaClientSDK::avsCommon\l::test::MockCapabilityAgent" alt="" coords="558,68,755,107"/>
<area shape="rect" id="node7" href="classalexa_client_s_d_k_1_1capability_agents_1_1aip_1_1_audio_input_processor.html" title="alexaClientSDK::capability\lAgents::aip::AudioInputProcessor" alt="" coords="547,131,766,169"/>
<area shape="rect" id="node8" href="classalexa_client_s_d_k_1_1capability_agents_1_1alerts_1_1_alerts_capability_agent.html" title="alexaClientSDK::capability\lAgents::alerts::AlertsCapabilityAgent" alt="" coords="538,193,775,232"/>
<area shape="rect" id="node9" href="classalexa_client_s_d_k_1_1capability_agents_1_1audio_player_1_1_audio_player.html" title="alexaClientSDK::capability\lAgents::audioPlayer::AudioPlayer" alt="" coords="546,256,766,295"/>
<area shape="rect" id="node10" href="classalexa_client_s_d_k_1_1capability_agents_1_1bluetooth_1_1_bluetooth.html" title="alexaClientSDK::capability\lAgents::bluetooth::Bluetooth" alt="" coords="562,319,751,357"/>
<area shape="rect" id="node11" href="classalexa_client_s_d_k_1_1capability_agents_1_1do_not_disturb_1_1_do_not_disturb_capability_agent.html" title="alexaClientSDK::capability\lAgents::doNotDisturb::DoNotDisturb\lCapabilityAgent" alt="" coords="539,381,774,433"/>
<area shape="rect" id="node12" href="classalexa_client_s_d_k_1_1capability_agents_1_1equalizer_1_1_equalizer_capability_agent.html" title="alexaClientSDK::capability\lAgents::equalizer::EqualizerCapabilityAgent" alt="" coords="516,457,797,496"/>
<area shape="rect" id="node13" href="classalexa_client_s_d_k_1_1capability_agents_1_1external_media_player_1_1_external_media_player.html" title="alexaClientSDK::capability\lAgents::externalMediaPlayer\l::ExternalMediaPlayer" alt="" coords="561,520,752,572"/>
<area shape="rect" id="node14" href="classalexa_client_s_d_k_1_1capability_agents_1_1interaction_model_1_1_interaction_model_capability_agent.html" title="alexaClientSDK::capability\lAgents::interactionModel\l::InteractionModelCapabilityAgent" alt="" coords="546,596,767,648"/>
<area shape="rect" id="node15" href="classalexa_client_s_d_k_1_1capability_agents_1_1mrm_1_1_m_r_m_capability_agent.html" title="alexaClientSDK::capability\lAgents::mrm::MRMCapabilityAgent" alt="" coords="542,672,771,711"/>
<area shape="rect" id="node16" href="classalexa_client_s_d_k_1_1capability_agents_1_1notifications_1_1_notifications_capability_agent.html" title="alexaClientSDK::capability\lAgents::notifications::\lNotificationsCapabilityAgent" alt="" coords="563,735,750,787"/>
<area shape="rect" id="node17" href="classalexa_client_s_d_k_1_1capability_agents_1_1speaker_manager_1_1_speaker_manager.html" title="alexaClientSDK::capability\lAgents::speakerManager\l::SpeakerManager" alt="" coords="568,811,745,863"/>
<area shape="rect" id="node18" href="classalexa_client_s_d_k_1_1capability_agents_1_1speech_synthesizer_1_1_speech_synthesizer.html" title="alexaClientSDK::capability\lAgents::speechSynthesizer\l::SpeechSynthesizer" alt="" coords="565,887,748,939"/>
<area shape="rect" id="node19" href="classalexa_client_s_d_k_1_1capability_agents_1_1system_1_1_endpoint_handler.html" title="alexaClientSDK::capability\lAgents::system::EndpointHandler" alt="" coords="547,963,766,1001"/>
<area shape="rect" id="node20" href="classalexa_client_s_d_k_1_1capability_agents_1_1system_1_1_revoke_authorization_handler.html" title="alexaClientSDK::capability\lAgents::system::RevokeAuthorization\lHandler" alt="" coords="535,1025,778,1077"/>
<area shape="rect" id="node21" href="classalexa_client_s_d_k_1_1capability_agents_1_1system_1_1_software_info_sender.html" title="alexaClientSDK::capability\lAgents::system::SoftwareInfoSender" alt="" coords="538,1101,775,1140"/>
<area shape="rect" id="node22" href="classalexa_client_s_d_k_1_1capability_agents_1_1system_1_1_user_inactivity_monitor.html" title="This class implements a CapabilityAgent that handles the SetEndpoint directive. " alt="" coords="556,1164,756,1216"/>
<area shape="rect" id="node23" href="classalexa_client_s_d_k_1_1capability_agents_1_1template_runtime_1_1_template_runtime.html" title="alexaClientSDK::capability\lAgents::templateRuntime\l::TemplateRuntime" alt="" coords="568,1240,745,1292"/>
</map>
<center><span class="legend">[<a href="graph_legend.html">legend</a>]</span></center></div>
<table class="memberdecls">
<tr class="heading"><td colspan="2"><h2 class="groupheader"><a name="pub-methods"></a>
Public Member Functions</h2></td></tr>
<tr class="memitem:a005d5be73f5a0b6d3306e37fb324249f"><td class="memItemLeft" align="right" valign="top">virtual&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classalexa_client_s_d_k_1_1avs_common_1_1sdk_interfaces_1_1_state_provider_interface.html#a005d5be73f5a0b6d3306e37fb324249f">~StateProviderInterface</a> ()=default</td></tr>
<tr class="separator:a005d5be73f5a0b6d3306e37fb324249f"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a004b06801aa76cffab2fa2d4bc0b45e1"><td class="memItemLeft" align="right" valign="top">virtual void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classalexa_client_s_d_k_1_1avs_common_1_1sdk_interfaces_1_1_state_provider_interface.html#a004b06801aa76cffab2fa2d4bc0b45e1">provideState</a> (const <a class="el" href="classalexa_client_s_d_k_1_1avs_common_1_1avs_1_1_namespace_and_name.html">avs::NamespaceAndName</a> &amp;stateProviderName, const unsigned int stateRequestToken)=0</td></tr>
<tr class="separator:a004b06801aa76cffab2fa2d4bc0b45e1"><td class="memSeparator" colspan="2">&#160;</td></tr>
</table>
<a name="details" id="details"></a><h2 class="groupheader">Detailed Description</h2>
<div class="textblock"><p class="">A <code>StateProvider</code> may be any client component whose state needs to be sent to the AVS. This specifies the interface to a <code>StateProvider</code>. </p>
</div><h2 class="groupheader">Constructor &amp; Destructor Documentation</h2>
<a id="a005d5be73f5a0b6d3306e37fb324249f"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a005d5be73f5a0b6d3306e37fb324249f">&#9670;&nbsp;</a></span>~StateProviderInterface()</h2>

<div class="memitem">
<div class="memproto">
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">virtual alexaClientSDK::avsCommon::sdkInterfaces::StateProviderInterface::~StateProviderInterface </td>
          <td>(</td>
          <td class="paramname"></td><td>)</td>
          <td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">virtual</span><span class="mlabel">default</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">
<p class="">Destructor. </p>

</div>
</div>
<h2 class="groupheader">Member Function Documentation</h2>
<a id="a004b06801aa76cffab2fa2d4bc0b45e1"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a004b06801aa76cffab2fa2d4bc0b45e1">&#9670;&nbsp;</a></span>provideState()</h2>

<div class="memitem">
<div class="memproto">
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">virtual void alexaClientSDK::avsCommon::sdkInterfaces::StateProviderInterface::provideState </td>
          <td>(</td>
          <td class="paramtype">const <a class="el" href="classalexa_client_s_d_k_1_1avs_common_1_1avs_1_1_namespace_and_name.html">avs::NamespaceAndName</a> &amp;&#160;</td>
          <td class="paramname"><em>stateProviderName</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">const unsigned int&#160;</td>
          <td class="paramname"><em>stateRequestToken</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">pure virtual</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">
<p class="">A request to a <code>StateProvider</code> to provide the state. The <code>StateProvider</code> should perform minimum processing and return quickly, otherwise it will block the processing of updating the states of other <code>StateProviders</code>. The <code>ContextManager</code> specifies a token which it uses to track the <code>getContext</code> request associated with this <code>provideState</code> request. The <code>stateProviderInterface</code> must use the same token when it updates its state via the <code>setState</code> call.</p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">stateProviderName</td><td>The name of the state provider. </td></tr>
    <tr><td class="paramname">stateRequestToken</td><td>The token to use in the <code>setState</code> call. </td></tr>
  </table>
  </dd>
</dl>

<p>Implemented in <a class="el" href="classalexa_client_s_d_k_1_1context_manager_1_1test_1_1_mock_state_provider.html#a78a98ac6558b3dca13d9534ac0d65174">alexaClientSDK::contextManager::test::MockStateProvider</a>, <a class="el" href="classalexa_client_s_d_k_1_1integration_1_1test_1_1test_state_provider.html#adc405e21289aea2f6c6af9ae55873b68">alexaClientSDK::integration::test::testStateProvider</a>, <a class="el" href="classalexa_client_s_d_k_1_1capability_agents_1_1speech_synthesizer_1_1_speech_synthesizer.html#a9aff31d23a969bf5148f48052cd4cad2">alexaClientSDK::capabilityAgents::speechSynthesizer::SpeechSynthesizer</a>, <a class="el" href="classalexa_client_s_d_k_1_1capability_agents_1_1external_media_player_1_1_external_media_player.html#a411c285401048584df6a15b673925b34">alexaClientSDK::capabilityAgents::externalMediaPlayer::ExternalMediaPlayer</a>, <a class="el" href="classalexa_client_s_d_k_1_1capability_agents_1_1notifications_1_1_notifications_capability_agent.html#a4cbb86c475f7f293a1e26ac074dbbab0">alexaClientSDK::capabilityAgents::notifications::NotificationsCapabilityAgent</a>, <a class="el" href="classalexa_client_s_d_k_1_1capability_agents_1_1audio_player_1_1_audio_player.html#a890a8422682e49f8bdc47b9b4843b426">alexaClientSDK::capabilityAgents::audioPlayer::AudioPlayer</a>, <a class="el" href="classalexa_client_s_d_k_1_1avs_common_1_1avs_1_1_capability_agent.html#af056b26452e6c4ca5855a72ec2bfcde4">alexaClientSDK::avsCommon::avs::CapabilityAgent</a>, <a class="el" href="classalexa_client_s_d_k_1_1afml_1_1_audio_activity_tracker.html#a27ffc2983f52a93427bcdcde829484c5">alexaClientSDK::afml::AudioActivityTracker</a>, and <a class="el" href="classalexa_client_s_d_k_1_1afml_1_1_visual_activity_tracker.html#ad36862324f796dccc2209c3451bdd3ca">alexaClientSDK::afml::VisualActivityTracker</a>.</p>

</div>
</div>
<hr/>The documentation for this class was generated from the following file:<ul>
<li>/workplace/avs-device-sdk/AVSCommon/SDKInterfaces/include/AVSCommon/SDKInterfaces/<a class="el" href="_state_provider_interface_8h_source.html">StateProviderInterface.h</a></li>
</ul>
</div><!-- contents -->
<html>
  <body>
    <p style="text-align:left;">
      AlexaClientSDK 1.13.0 - Copyright 2016-2019 Amazon.com, Inc. or its affiliates. All Rights Reserved.
      <span style="float:right;">
	Licensed under the <a HREF=http://aws.amazon.com/apache2.0/>Apache License, Version 2.0</a>
      </span>
    </p>
  </body>
</html>
